#include <bits/stdc++.h>
typedef long long ll;

using namespace std;

ll nzd(ll x, ll y){
    if(y == 0)
        return x;
    else
        return nzd(y, x%y);
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    int n, m;
    ll prvi, pom;
    ll nzd1, nzd2;
    for(int i = 0;i < t;i++){
        cin >> n >> m;
        ll prihvacene[n-1], odbijene[m];
        cin >> prvi;
        cin >> pom;
        prihvacene[0] = abs(prvi - pom);
        nzd1 = prihvacene[0];
        for(int j = 1;j < n-1;j++){
            cin >> pom;
            prihvacene[j] = abs(prvi - pom);
            nzd1 = nzd(nzd1, prihvacene[j]);
        }
        cin >> pom;
        odbijene[0] = abs(prvi - pom);
        nzd2 = odbijene[0];
        for(int k = 1;k < m;k++){
            cin >> pom;
            odbijene[k] = abs(prvi - pom);
            nzd2 = nzd(nzd2, odbijene[k]);
        }
        if(nzd1 != nzd2)
            cout << "1\n";
        else
            cout << "0\n";
    }
}